package com.fjhx.form.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.baomidou.dynamic.datasource.toolkit.DynamicDataSourceContextHolder;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.account.entity.account.dto.AccountRunningWaterDto;
import com.fjhx.account.entity.account.po.AccountRunningWater;
import com.fjhx.account.service.account.AccountRunningWaterService;
import com.fjhx.common.constant.SourceConstant;
import com.fjhx.common.utils.Assert;
import com.fjhx.common.utils.excel.util.ExcelUtil;
import com.fjhx.form.entity.RemitDetailSelectDto;
import com.fjhx.form.entity.RemitDetailVo;
import com.fjhx.form.entity.SubjectBalanceBo;
import com.fjhx.form.entity.SubjectBalanceSelectDto;
import com.fjhx.form.entity.calculate.po.CalculateItemBalance;
import com.fjhx.form.mapper.FinanceReportMapper;
import com.fjhx.form.service.FinanceReportService;
import com.fjhx.form.service.calculate.CalculateItemBalanceService;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.ruoyi.common.utils.wrapper.SqlField;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
public class FinanceReportServiceImpl implements FinanceReportService {
    @Resource
    private FinanceReportMapper financeReportMapper;
    @Resource
    private CalculateItemBalanceService calculateItemBalanceService;
    @Resource
    private AccountRunningWaterService accountRunningWaterService;

    @Override
    public List<SubjectBalanceBo> subjectBalance(SubjectBalanceSelectDto dto) {
        Assert.notEmpty(dto.getYear(), "年份不能为空！");
        IWrapper<Object> wrapper = IWrapper.getWrapper();


        wrapper.apply("YEAR ( t1.expenses_time ) = {0}", dto.getYear());

        wrapper.keyword(dto.getKeyword(),
                new SqlField("asj.subjects_name"),
                new SqlField("t1.calculate_item_str")
        );


        Map<String, BigDecimal> subjectsBalanceMap = calculateItemBalanceService.mapKV(
                CalculateItemBalance::getIdStr,
                CalculateItemBalance::getBalanceAmount,
                q -> q.eq(CalculateItemBalance::getYear, dto.getYear() - 1)
        );


        SubjectBalanceBo totalBo = new SubjectBalanceBo();


        List<SubjectBalanceBo> subjectBalanceBos = financeReportMapper.subjectBalance(wrapper, dto);
        for (SubjectBalanceBo subjectBalanceBo : subjectBalanceBos) {
            BigDecimal month1Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth1Amount(), BigDecimal.ZERO);
            BigDecimal month2Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth2Amount(), BigDecimal.ZERO);
            BigDecimal month3Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth3Amount(), BigDecimal.ZERO);
            BigDecimal month4Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth4Amount(), BigDecimal.ZERO);
            BigDecimal month5Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth5Amount(), BigDecimal.ZERO);
            BigDecimal month6Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth6Amount(), BigDecimal.ZERO);
            BigDecimal month7Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth7Amount(), BigDecimal.ZERO);
            BigDecimal month8Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth8Amount(), BigDecimal.ZERO);
            BigDecimal month9Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth9Amount(), BigDecimal.ZERO);
            BigDecimal month10Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth10Amount(), BigDecimal.ZERO);
            BigDecimal month11Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth11Amount(), BigDecimal.ZERO);
            BigDecimal month12Amount = ObjectUtil.defaultIfNull(subjectBalanceBo.getMonth12Amount(), BigDecimal.ZERO);

            //获取期出余额
            BigDecimal yearBeginBalance = ObjectUtil.defaultIfNull(subjectsBalanceMap.get(subjectBalanceBo.getSubjectsId()), BigDecimal.ZERO);

            subjectBalanceBo.setYearBeginBalance(yearBeginBalance);
            //余额 = 年初余额 + (-年初借方) + 1-12月 + 本期发生
            //1-12月合计
            BigDecimal janToDecSum = month1Amount.add(month2Amount).add(month3Amount).add(month4Amount)
                    .add(month5Amount).add(month6Amount).add(month7Amount).add(month8Amount)
                    .add(month9Amount).add(month10Amount).add(month11Amount).add(month12Amount);
            //年初借方
            BigDecimal yearBeginBorrowAmount = ObjectUtil.defaultIfNull(subjectBalanceBo.getYearBeginBorrowAmount(), BigDecimal.ZERO);
            //计算余额
            BigDecimal balanceAmount = yearBeginBalance.subtract(yearBeginBorrowAmount).add(janToDecSum).add(subjectBalanceBo.getTradeAmount());
            subjectBalanceBo.setBalanceAmount(balanceAmount);

            totalBo.setSubjectsName("合计");
            totalBo.setYearBeginBalance(ObjectUtil.defaultIfNull(totalBo.getYearBeginBalance(), BigDecimal.ZERO).add(subjectBalanceBo.getYearBeginBalance()));
            totalBo.setYearBeginBorrowAmount(ObjectUtil.defaultIfNull(totalBo.getYearBeginBorrowAmount(), BigDecimal.ZERO).add(ObjectUtil.defaultIfNull(subjectBalanceBo.getYearBeginBorrowAmount(), BigDecimal.ZERO)));
            totalBo.setMonth1Amount(ObjectUtil.defaultIfNull(totalBo.getMonth1Amount(), BigDecimal.ZERO).add(month1Amount));
            totalBo.setMonth2Amount(ObjectUtil.defaultIfNull(totalBo.getMonth2Amount(), BigDecimal.ZERO).add(month2Amount));
            totalBo.setMonth3Amount(ObjectUtil.defaultIfNull(totalBo.getMonth3Amount(), BigDecimal.ZERO).add(month3Amount));
            totalBo.setMonth4Amount(ObjectUtil.defaultIfNull(totalBo.getMonth4Amount(), BigDecimal.ZERO).add(month4Amount));
            totalBo.setMonth5Amount(ObjectUtil.defaultIfNull(totalBo.getMonth5Amount(), BigDecimal.ZERO).add(month5Amount));
            totalBo.setMonth6Amount(ObjectUtil.defaultIfNull(totalBo.getMonth6Amount(), BigDecimal.ZERO).add(month6Amount));
            totalBo.setMonth7Amount(ObjectUtil.defaultIfNull(totalBo.getMonth7Amount(), BigDecimal.ZERO).add(month7Amount));
            totalBo.setMonth8Amount(ObjectUtil.defaultIfNull(totalBo.getMonth8Amount(), BigDecimal.ZERO).add(month8Amount));
            totalBo.setMonth9Amount(ObjectUtil.defaultIfNull(totalBo.getMonth9Amount(), BigDecimal.ZERO).add(month9Amount));
            totalBo.setMonth10Amount(ObjectUtil.defaultIfNull(totalBo.getMonth10Amount(), BigDecimal.ZERO).add(month10Amount));
            totalBo.setMonth11Amount(ObjectUtil.defaultIfNull(totalBo.getMonth11Amount(), BigDecimal.ZERO).add(month11Amount));
            totalBo.setMonth12Amount(ObjectUtil.defaultIfNull(totalBo.getMonth12Amount(), BigDecimal.ZERO).add(month12Amount));
            totalBo.setTradeAmount(ObjectUtil.defaultIfNull(totalBo.getTradeAmount(), BigDecimal.ZERO).add(subjectBalanceBo.getTradeAmount()));
            totalBo.setBalanceAmount(ObjectUtil.defaultIfNull(totalBo.getBalanceAmount(), BigDecimal.ZERO).add(subjectBalanceBo.getBalanceAmount()));
        }

        subjectBalanceBos.add(totalBo);

        return subjectBalanceBos;
    }

    /**
     * 每月1日0点1分 赋值客户上月科目余额
     */
//    @PostConstruct
    @Scheduled(cron = "0 1 0 1 * ?")
    public void autoSaveReceivableAccountsEnding() {
        DynamicDataSourceContextHolder.push(SourceConstant.BASE);
        SecurityUtils.setTenantId("000000");

        DateTime lastMonth = DateUtil.offsetMonth(new Date(), -1);

        SubjectBalanceSelectDto dto = new SubjectBalanceSelectDto();
        dto.setYear(DateUtil.year(lastMonth));
        List<SubjectBalanceBo> subjectBalanceBos = subjectBalance(dto);

        //每过一个月保存一次余额
        for (SubjectBalanceBo receivableAccount : subjectBalanceBos) {
            //获取上一月数据
            CalculateItemBalance lastCalculateItemBalance = calculateItemBalanceService.getOne(q -> q
                    .eq(CalculateItemBalance::getYear, dto.getYear())
                    .eq(CalculateItemBalance::getIdStr, receivableAccount.getSubjectsCalculateItemIds())
            );
            if (ObjectUtil.isEmpty(lastCalculateItemBalance)) {
                lastCalculateItemBalance = new CalculateItemBalance();
                lastCalculateItemBalance.setYear(dto.getYear());
                lastCalculateItemBalance.setIdStr(receivableAccount.getSubjectsCalculateItemIds());
            }

            //保存余额
            lastCalculateItemBalance.setBalanceAmount(receivableAccount.getBalanceAmount());
            calculateItemBalanceService.saveOrUpdate(lastCalculateItemBalance);
        }

        SecurityUtils.clearTenantId();
        DynamicDataSourceContextHolder.clear();
    }

    private void setRemitDetailPageWrapper(RemitDetailSelectDto dto, IWrapper wrapper) {
        wrapper.keyword(dto.getKeyword(),
                new SqlField("t1.contract_codes"),
                new SqlField("t2.subject_name"),
                new SqlField("t1.customerShortName"),
                new SqlField("t2.supplier_names"),
                new SqlField("cc.voucher_no"),
                new SqlField("arw.amount"),
                new SqlField("am.`alias`")
        );

        //交易时间范围过滤
        wrapper.ge("arw.transaction_time", dto.getBeginTime());
        wrapper.le("arw.transaction_time", dto.getEndTime());

        wrapper.orderByDesc("arw.transaction_time");
    }

    @Override
    public Page<RemitDetailVo> getRemitDetailPage(RemitDetailSelectDto dto) {
        IWrapper<Object> wrapper = IWrapper.getWrapper();

        //设置查询条件
        setRemitDetailPageWrapper(dto, wrapper);

        Page<RemitDetailVo> page = financeReportMapper.getRemitDetailPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public void remitDetailExcelExport(RemitDetailSelectDto dto, HttpServletResponse httpServletResponse) {
        IWrapper<Object> wrapper = IWrapper.getWrapper();

        //设置查询条件
        setRemitDetailPageWrapper(dto, wrapper);

        List<RemitDetailVo> records = financeReportMapper.getRemitDetailPage(wrapper);
        //导出Excel
        ExcelUtil.export(httpServletResponse, records, RemitDetailVo.class);
    }

    @DSTransactional
    @Override
    public void editRemitDetail(AccountRunningWaterDto dto) {
        Assert.notEmpty(dto.getId(), "id不能为空！");
        accountRunningWaterService.update(q -> q
                .eq(AccountRunningWater::getId, dto.getId())
                .set(AccountRunningWater::getOppositeSubjectName, dto.getOppositeSubjectName())
                .set(AccountRunningWater::getSaleExpenseCategory, dto.getSaleExpenseCategory())
                .set(AccountRunningWater::getUpdateTime, new Date())
                .set(AccountRunningWater::getUpdateUser, SecurityUtils.getUserId())
        );
    }
}
